Index: sasmodels/details.py
===================================================================
--- sasmodels/details.py	(revision ccd5f018ad394bf78c2726b92d428f6903233b21)
+++ sasmodels/details.py	(revision f39759c773168cc38c66528d0c9c86a7957986fc)
@@ -15,5 +15,5 @@
 
 import numpy as np  # type: ignore
-from numpy import pi, cos, sin
+from numpy import pi, cos, sin, radians
 
 try:
@@ -29,9 +29,10 @@
 
 try:
-    from typing import List
+    from typing import List, Tuple, Sequence
 except ImportError:
     pass
 else:
     from .modelinfo import ModelInfo
+    from .modelinfo import ParameterTable
 
 
@@ -53,5 +54,5 @@
     coordinates, the total circumference decreases as latitude varies from
     pi r^2 at the equator to 0 at the pole, and the weight associated
-    with a range of phi values needs to be scaled by this circumference.
+    with a range of latitude values needs to be scaled by this circumference.
     This scale factor needs to be updated each time the theta value
     changes.  *theta_par* indicates which of the values in the parameter
@@ -231,5 +232,7 @@
     nvalues = kernel.info.parameters.nvalues
     scalars = [(v[0] if len(v) else np.NaN) for v, w in pairs]
-    values, weights = zip(*pairs[2:npars+2]) if npars else ((),())
+    # skipping scale and background when building values and weights
+    values, weights = zip(*pairs[2:npars+2]) if npars else ((), ())
+    weights = correct_theta_weights(kernel.info.parameters, values, weights)
     length = np.array([len(w) for w in weights])
     offset = np.cumsum(np.hstack((0, length)))
@@ -244,6 +247,32 @@
     return call_details, data, is_magnetic
 
+def correct_theta_weights(parameters, values, weights):
+    # type: (ParameterTable, Sequence[np.ndarray], Sequence[np.ndarray]) -> Sequence[np.ndarray]
+    """
+    If there is a theta parameter, update the weights of that parameter so that
+    the cosine weighting required for polar integration is preserved.  Avoid
+    evaluation strictly at the pole, which would otherwise send the weight to
+    zero.
+
+    Note: values and weights do not include scale and background
+    """
+    # TODO: document code, explaining why scale and background are skipped
+    # given that we don't have scale and background in the list, we
+    # should be calling the variables something other than values and weights
+    # Apparently the parameters.theta_offset similarly skips scale and
+    # and background, so the indexing works out.
+    if parameters.theta_offset >= 0:
+        index = parameters.theta_offset
+        theta = values[index]
+        theta_weight = np.minimum(abs(cos(radians(theta))), 1e-6)
+        # copy the weights list so we can update it
+        weights = list(weights)
+        weights[index] = theta_weight*np.asarray(weights[index])
+        weights = tuple(weights)
+    return weights
+
 
 def convert_magnetism(parameters, values):
+    # type: (ParameterTable, Sequence[np.ndarray]) -> bool
     """
     Convert magnetism values from polar to rectangular coordinates.
@@ -255,5 +284,5 @@
     scale = mag[:,0]
     if np.any(scale):
-        theta, phi = mag[:, 1]*pi/180., mag[:, 2]*pi/180.
+        theta, phi = radians(mag[:, 1]), radians(mag[:, 2])
         cos_theta = cos(theta)
         mag[:, 0] = scale*cos_theta*cos(phi)  # mx
@@ -269,4 +298,12 @@
     """
     Create a mesh grid of dispersion parameters and weights.
+
+    pars is a list of pairs (values, weights), where the values are the
+    individual parameter values at which to evaluate the polydispersity
+    distribution and weights are the weights associated with each value.
+
+    Only the volume parameters should be included in this list.  Orientation
+    parameters do not affect the calculation of effective radius or volume
+    ratio.
 
     Returns [p1,p2,...],w where pj is a vector of values for parameter j
Index: sasmodels/kernel_iq.c
===================================================================
--- sasmodels/kernel_iq.c	(revision bde38b559fcdc618ebafdbb69cf7af6120ea8466)
+++ sasmodels/kernel_iq.c	(revision d4c33d66aa792e691ad5eb91b36d3e854e88f383)
@@ -25,5 +25,5 @@
     int32_t num_weights;        // total length of the weights vector
     int32_t num_active;         // number of non-trivial pd loops
-    int32_t theta_par;          // id of spherical correction variable
+    int32_t theta_par;          // id of spherical correction variable (not used)
 } ProblemDetails;
 
@@ -173,15 +173,4 @@
 
 
-#if MAX_PD>0
-  const int theta_par = details->theta_par;
-  const int fast_theta = (theta_par == p0);
-  const int slow_theta = (theta_par >= 0 && !fast_theta);
-  double spherical_correction = 1.0;
-#else
-  // Note: if not polydisperse the weights cancel and we don't need the
-  // spherical correction.
-  const double spherical_correction = 1.0;
-#endif
-
   int step = pd_start;
 
@@ -220,14 +209,8 @@
 #endif
 #if MAX_PD>0
-  if (slow_theta) { // Theta is not in inner loop
-    spherical_correction = fmax(fabs(cos(M_PI_180*local_values.vector[theta_par])), 1.e-6);
-  }
   while(i0 < n0) {
     local_values.vector[p0] = v0[i0];
     double weight0 = w0[i0] * weight1;
 //printf("step:%d level %d: p:%d i:%d n:%d value:%g weight:%g\n", step, 0, p0, i0, n0, local_values.vector[p0], weight0);
-    if (fast_theta) { // Theta is in inner loop
-      spherical_correction = fmax(fabs(cos(M_PI_180*local_values.vector[p0])), 1.e-6);
-    }
 #else
     const double weight0 = 1.0;
@@ -244,8 +227,5 @@
       // Note: weight==0 must always be excluded
       if (weight0 > cutoff) {
-        // spherical correction is set at a minimum of 1e-6, otherwise there
-        // would be problems looking at models with theta=90.
-        const double weight = weight0 * spherical_correction;
-        pd_norm += weight * CALL_VOLUME(local_values.table);
+        pd_norm += weight0 * CALL_VOLUME(local_values.table);
 
         #ifdef USE_OPENMP
@@ -304,5 +284,5 @@
 #endif // !MAGNETIC
 //printf("q_index:%d %g %g %g %g\n",q_index, scattering, weight, spherical_correction, weight0);
-          result[q_index] += weight * scattering;
+          result[q_index] += weight0 * scattering;
         }
       }
Index: sasmodels/kernel_iq.cl
===================================================================
--- sasmodels/kernel_iq.cl	(revision bde38b559fcdc618ebafdbb69cf7af6120ea8466)
+++ sasmodels/kernel_iq.cl	(revision d4c33d66aa792e691ad5eb91b36d3e854e88f383)
@@ -25,5 +25,5 @@
     int32_t num_weights;        // total length of the weights vector
     int32_t num_active;         // number of non-trivial pd loops
-    int32_t theta_par;          // id of spherical correction variable
+    int32_t theta_par;          // id of spherical correction variable (not used)
 } ProblemDetails;
 
@@ -169,15 +169,4 @@
 
 
-#if MAX_PD>0
-  const int theta_par = details->theta_par;
-  const bool fast_theta = (theta_par == p0);
-  const bool slow_theta = (theta_par >= 0 && !fast_theta);
-  double spherical_correction = 1.0;
-#else
-  // Note: if not polydisperse the weights cancel and we don't need the
-  // spherical correction.
-  const double spherical_correction = 1.0;
-#endif
-
   int step = pd_start;
 
@@ -217,14 +206,8 @@
 #endif
 #if MAX_PD>0
-  if (slow_theta) { // Theta is not in inner loop
-    spherical_correction = fmax(fabs(cos(M_PI_180*local_values.vector[theta_par])), 1.e-6);
-  }
   while(i0 < n0) {
     local_values.vector[p0] = v0[i0];
     double weight0 = w0[i0] * weight1;
 //if (q_index == 0) printf("step:%d level %d: p:%d i:%d n:%d value:%g weight:%g\n", step, 0, p0, i0, n0, local_values.vector[p0], weight0);
-    if (fast_theta) { // Theta is in inner loop
-      spherical_correction = fmax(fabs(cos(M_PI_180*local_values.vector[p0])), 1.e-6);
-    }
 #else
     const double weight0 = 1.0;
@@ -232,5 +215,4 @@
 
 //if (q_index == 0) {printf("step:%d of %d, pars:",step,pd_stop); for (int i=0; i < NUM_PARS; i++) printf("p%d=%g ",i, local_values.vector[i]); printf("\n"); }
-//if (q_index == 0) printf("sphcor: %g\n", spherical_correction);
 
     #ifdef INVALID
@@ -241,8 +223,5 @@
       // Note: weight==0 must always be excluded
       if (weight0 > cutoff) {
-        // spherical correction is set at a minimum of 1e-6, otherwise there
-        // would be problems looking at models with theta=90.
-        const double weight = weight0 * spherical_correction;
-        pd_norm += weight * CALL_VOLUME(local_values.table);
+        pd_norm += weight0 * CALL_VOLUME(local_values.table);
 
 #if defined(MAGNETIC) && NUM_MAGNETIC > 0
@@ -296,5 +275,5 @@
         const double scattering = CALL_IQ(q, q_index, local_values.table);
 #endif // !MAGNETIC
-        this_result += weight * scattering;
+        this_result += weight0 * scattering;
       }
     }
Index: sasmodels/kernelpy.py
===================================================================
--- sasmodels/kernelpy.py	(revision dbfd47189324c900d6e5cf98a210576a86204ced)
+++ sasmodels/kernelpy.py	(revision d4c33d66aa792e691ad5eb91b36d3e854e88f383)
@@ -197,10 +197,8 @@
 
     pd_norm = 0.0
-    spherical_correction = 1.0
     partial_weight = np.NaN
     weight = np.NaN
 
     p0_par = call_details.pd_par[0]
-    p0_is_theta = (p0_par == call_details.theta_par)
     p0_length = call_details.pd_length[0]
     p0_index = p0_length
@@ -219,14 +217,8 @@
             parameters[pd_par] = pd_value[pd_offset+pd_index]
             partial_weight = np.prod(pd_weight[pd_offset+pd_index][1:])
-            if call_details.theta_par >= 0:
-                cor = sin(pi / 180 * parameters[call_details.theta_par])
-                spherical_correction = max(abs(cor), 1e-6)
             p0_index = loop_index%p0_length
 
         weight = partial_weight * pd_weight[p0_offset + p0_index]
         parameters[p0_par] = pd_value[p0_offset + p0_index]
-        if p0_is_theta:
-            cor = cos(pi/180 * parameters[p0_par])
-            spherical_correction = max(abs(cor), 1e-6)
         p0_index += 1
         if weight > cutoff:
@@ -239,5 +231,4 @@
 
             # update value and norm
-            weight *= spherical_correction
             total += weight * Iq
             pd_norm += weight * form_volume()
Index: sasmodels/model_test.py
===================================================================
--- sasmodels/model_test.py	(revision bb4b50990533a15ceda4443988db938e13a28a2b)
+++ sasmodels/model_test.py	(revision bb4b50990533a15ceda4443988db938e13a28a2b)
@@ -79,7 +79,7 @@
     suite = unittest.TestSuite()
 
-    if models[0] == 'all':
+    if models[0] in core.KINDS:
         skip = models[1:]
-        models = list_models()
+        models = list_models(models[0])
     else:
         skip = []
Index: sasmodels/models/_py_parallelepiped.py
===================================================================
--- sasmodels/models/_py_parallelepiped.py	(revision 597878a0f8b1b1b38cfce28323dfa620bdbaea50)
+++ sasmodels/models/_py_parallelepiped.py	(revision 597878a0f8b1b1b38cfce28323dfa620bdbaea50)
@@ -0,0 +1,316 @@
+# parallelepiped model
+# Note: model title and parameter table are inserted automatically
+r"""
+The form factor is normalized by the particle volume.
+For information about polarised and magnetic scattering, see
+the :ref:`magnetism` documentation.
+
+Definition
+----------
+
+ This model calculates the scattering from a rectangular parallelepiped
+ (\:numref:`parallelepiped-image`\).
+ If you need to apply polydispersity, see also :ref:`rectangular-prism`.
+
+.. _parallelepiped-image:
+
+
+.. figure:: img/parallelepiped_geometry.jpg
+
+   Parallelepiped with the corresponding definition of sides.
+
+.. note::
+
+   The edge of the solid used to have to satisfy the condition that $A < B < C$.
+   After some improvements to the effective radius calculation, used with
+   an S(Q), it is beleived that this is no longer the case.
+
+The 1D scattering intensity $I(q)$ is calculated as:
+
+.. Comment by Miguel Gonzalez:
+   I am modifying the original text because I find the notation a little bit
+   confusing. I think that in most textbooks/papers, the notation P(Q) is
+   used for the form factor (adim, P(Q=0)=1), although F(q) seems also to
+   be used. But here (as for many other models), P(q) is used to represent
+   the scattering intensity (in cm-1 normally). It would be good to agree on
+   a common notation.
+
+.. math::
+
+    I(q) = \frac{\text{scale}}{V} (\Delta\rho \cdot V)^2
+           \left< P(q, \alpha) \right> + \text{background}
+
+where the volume $V = A B C$, the contrast is defined as
+$\Delta\rho = \rho_\text{p} - \rho_\text{solvent}$,
+$P(q, \alpha)$ is the form factor corresponding to a parallelepiped oriented
+at an angle $\alpha$ (angle between the long axis C and $\vec q$),
+and the averaging $\left<\ldots\right>$ is applied over all orientations.
+
+Assuming $a = A/B < 1$, $b = B /B = 1$, and $c = C/B > 1$, the
+form factor is given by (Mittelbach and Porod, 1961)
+
+.. math::
+
+    P(q, \alpha) = \int_0^1 \phi_Q\left(\mu \sqrt{1-\sigma^2},a\right)
+        \left[S(\mu c \sigma/2)\right]^2 d\sigma
+
+with
+
+.. math::
+
+    \phi_Q(\mu,a) &= \int_0^1
+        \left\{S\left[\frac{\mu}{2}\cos\left(\frac{\pi}{2}u\right)\right]
+               S\left[\frac{\mu a}{2}\sin\left(\frac{\pi}{2}u\right)\right]
+               \right\}^2 du
+
+    S(x) &= \frac{\sin x}{x}
+
+    \mu &= qB
+
+The scattering intensity per unit volume is returned in units of |cm^-1|.
+
+NB: The 2nd virial coefficient of the parallelepiped is calculated based on
+the averaged effective radius, after appropriately sorting the three
+dimensions, to give an oblate or prolate particle, $(=\sqrt{AB/\pi})$ and
+length $(= C)$ values, and used as the effective radius for
+$S(q)$ when $P(q) \cdot S(q)$ is applied.
+
+To provide easy access to the orientation of the parallelepiped, we define
+three angles $\theta$, $\phi$ and $\Psi$. The definition of $\theta$ and
+$\phi$ is the same as for the cylinder model (see also figures below).
+
+.. Comment by Miguel Gonzalez:
+   The following text has been commented because I think there are two
+   mistakes. Psi is the rotational angle around C (but I cannot understand
+   what it means against the q plane) and psi=0 corresponds to a||x and b||y.
+
+   The angle $\Psi$ is the rotational angle around the $C$ axis against
+   the $q$ plane. For example, $\Psi = 0$ when the $B$ axis is parallel
+   to the $x$-axis of the detector.
+
+The angle $\Psi$ is the rotational angle around the $C$ axis.
+For $\theta = 0$ and $\phi = 0$, $\Psi = 0$ corresponds to the $B$ axis
+oriented parallel to the y-axis of the detector with $A$ along the z-axis.
+For other $\theta$, $\phi$ values, the parallelepiped has to be first rotated
+$\theta$ degrees around $z$ and $\phi$ degrees around $y$,
+before doing a final rotation of $\Psi$ degrees around the resulting $C$ to
+obtain the final orientation of the parallelepiped.
+For example, for $\theta = 0$ and $\phi = 90$, we have that $\Psi = 0$
+corresponds to $A$ along $x$ and $B$ along $y$,
+while for $\theta = 90$ and $\phi = 0$, $\Psi = 0$ corresponds to
+$A$ along $z$ and $B$ along $x$.
+
+.. _parallelepiped-orientation:
+
+.. figure:: img/parallelepiped_angle_definition.png
+
+    Definition of the angles for oriented parallelepiped, shown with $A<B<C$.
+
+.. figure:: img/parallelepiped_angle_projection.png
+
+    Examples of the angles for an oriented parallelepiped against the
+    detector plane.
+
+On introducing "Orientational Distribution" in the angles, "distribution of theta" and "distribution of phi" parameters will
+appear. These are actually rotations about axes $\delta_1$ and $\delta_2$ of the parallelepiped, perpendicular to the $a$ x $c$ and $b$ x $c$ faces. 
+(When $\theta = \phi = 0$ these are parallel to the $Y$ and $X$ axes of the instrument.) The third orientation distribution, in $\psi$, is 
+about the $c$ axis of the particle, perpendicular to the $a$ x $b$ face. Some experimentation may be required to 
+understand the 2d patterns fully. (Earlier implementations had numerical integration issues in some circumstances when orientation 
+distributions passed through 90 degrees, such situations, with very broad distributions, should still be approached with care.) 
+
+    
+For a given orientation of the parallelepiped, the 2D form factor is
+calculated as
+
+.. math::
+
+    P(q_x, q_y) = \left[\frac{\sin(\tfrac{1}{2}qA\cos\alpha)}{(\tfrac{1}{2}qA\cos\alpha)}\right]^2
+                  \left[\frac{\sin(\tfrac{1}{2}qB\cos\beta)}{(\tfrac{1}{2}qB\cos\beta)}\right]^2
+                  \left[\frac{\sin(\tfrac{1}{2}qC\cos\gamma)}{(\tfrac{1}{2}qC\cos\gamma)}\right]^2
+
+with
+
+.. math::
+
+    \cos\alpha &= \hat A \cdot \hat q,
+
+    \cos\beta  &= \hat B \cdot \hat q,
+
+    \cos\gamma &= \hat C \cdot \hat q
+
+and the scattering intensity as:
+
+.. math::
+
+    I(q_x, q_y) = \frac{\text{scale}}{V} V^2 \Delta\rho^2 P(q_x, q_y)
+            + \text{background}
+
+.. Comment by Miguel Gonzalez:
+   This reflects the logic of the code, as in parallelepiped.c the call
+   to _pkernel returns $P(q_x, q_y)$ and then this is multiplied by
+   $V^2 * (\Delta \rho)^2$. And finally outside parallelepiped.c it will be
+   multiplied by scale, normalized by $V$ and the background added. But
+   mathematically it makes more sense to write
+   $I(q_x, q_y) = \text{scale} V \Delta\rho^2 P(q_x, q_y) + \text{background}$,
+   with scale being the volume fraction.
+
+
+Validation
+----------
+
+Validation of the code was done by comparing the output of the 1D calculation
+to the angular average of the output of a 2D calculation over all possible
+angles.
+
+
+References
+----------
+
+P Mittelbach and G Porod, *Acta Physica Austriaca*, 14 (1961) 185-211
+
+R Nayuk and K Huber, *Z. Phys. Chem.*, 226 (2012) 837-854
+
+Authorship and Verification
+----------------------------
+
+* **Author:** This model is based on form factor calculations implemented
+    in a c-library provided by the NIST Center for Neutron Research (Kline, 2006).
+* **Last Modified by:**  Paul Kienzle **Date:** April 05, 2017
+* **Last Reviewed by:**  Richard Heenan **Date:** April 06, 2017
+
+"""
+
+import numpy as np
+from numpy import pi, inf, sqrt, sin, cos, radians
+from sasmodels.special import sas_sinx_x, Gauss76Wt, Gauss76Z, square, ORIENT_ASYMMETRIC
+
+name = "parallelepiped"
+title = "Rectangular parallelepiped with uniform scattering length density."
+description = """
+    I(q)= scale*V*(sld - sld_solvent)^2*P(q,alpha)+background
+        P(q,alpha) = integral from 0 to 1 of ...
+           phi(mu*sqrt(1-sigma^2),a) * S(mu*c*sigma/2)^2 * dsigma
+        with
+            phi(mu,a) = integral from 0 to 1 of ..
+            (S((/mu/2)*cos(pi*u/2))*S((mu*a/2)*sin(pi*u/2)))^2 * du
+            S(x) = sin(x)/x
+            mu = q*B
+        V: Volume of the rectangular parallelepiped
+        alpha: angle between the long axis of the
+            parallelepiped and the q-vector for 1D
+"""
+category = "shape:parallelepiped"
+
+#             ["name", "units", default, [lower, upper], "type","description"],
+parameters = [["sld", "1e-6/Ang^2", 4, [-inf, inf], "sld",
+               "Parallelepiped scattering length density"],
+              ["sld_solvent", "1e-6/Ang^2", 1, [-inf, inf], "sld",
+               "Solvent scattering length density"],
+              ["length_a", "Ang", 35, [0, inf], "volume",
+               "Shorter side of the parallelepiped"],
+              ["length_b", "Ang", 75, [0, inf], "volume",
+               "Second side of the parallelepiped"],
+              ["length_c", "Ang", 400, [0, inf], "volume",
+               "Larger side of the parallelepiped"],
+              ["theta", "degrees", 60, [-360, 360], "orientation",
+               "c axis to beam angle"],
+              ["phi", "degrees", 60, [-360, 360], "orientation",
+               "rotation about beam"],
+              ["psi", "degrees", 60, [-360, 360], "orientation",
+               "rotation about c axis"],
+             ]
+
+def form_volume(length_a, length_b, length_c):
+    return length_a * length_b * length_c
+             
+def Iq(q,
+        sld, solvent_sld,
+        length_a, length_b, length_c):
+
+    mu = 0.5 * q * length_b
+    
+    # Scale sides by B
+    a_scaled = length_a / length_b
+    c_scaled = length_c / length_b
+        
+    # outer integral (with gauss points), integration limits = 0, 1
+    outer_total = 0 #initialize integral
+
+    for i in range(76):
+        sigma = 0.5 * ( Gauss76Z[i] + 1.0 );
+        mu_proj = mu * sqrt(1.0-sigma*sigma)
+
+        # inner integral (with gauss points), integration limits = 0, 1
+        # corresponding to angles from 0 to pi/2.
+        inner_total = 0.0
+        for j in range(76):
+            uu = 0.5 * ( Gauss76Z[j] + 1.0 );
+            sin_uu, cos_uu = sin(0.5*pi*uu), cos(0.5*pi*uu)
+            si1 = sas_sinx_x(mu_proj * sin_uu * a_scaled)
+            si2 = sas_sinx_x(mu_proj * cos_uu)
+            inner_total += Gauss76Wt[j] * square(si1 * si2)
+        inner_total *= 0.5
+
+        si = sas_sinx_x(mu * c_scaled * sigma)
+        outer_total += Gauss76Wt[i] * inner_total * si * si
+    outer_total *= 0.5
+
+    # Multiply by contrast^2 and convert from [1e-12 A-1] to [cm-1]
+    V = form_volume(length_a, length_b, length_c)
+    drho = (sld-solvent_sld)
+    return 1.0e-4 * square(drho * V) * outer_total
+Iq.vectorized = True
+
+def Iqxy(qx, qy,
+        sld, solvent_sld,
+        length_a, length_b, length_c,
+        theta, phi, psi):
+    q, xhat, yhat, zhat = ORIENT_ASYMMETRIC(qx, qy, theta, phi, psi)
+    siA = sas_sinx_x(0.5*length_a*q*xhat)
+    siB = sas_sinx_x(0.5*length_b*q*yhat)
+    siC = sas_sinx_x(0.5*length_c*q*zhat)
+    V = form_volume(length_a, length_b, length_c)
+    drho = (sld - solvent_sld)
+    form = V * drho * siA * siB * siC
+    # Square and convert from [1e-12 A-1] to [cm-1]
+    return 1.0e-4 * form * form
+Iqxy.vectorized = True
+
+
+def ER(length_a, length_b, length_c):
+    """
+    Return effective radius (ER) for P(q)*S(q)
+    """
+    # now that axes can be in any size order, need to sort a,b,c where a~b and c is either much smaller
+    # or much larger
+    abc = np.vstack((length_a, length_b, length_c))
+    abc = np.sort(abc, axis=0)
+    selector = (abc[1] - abc[0]) > (abc[2] - abc[1])
+    length = np.where(selector, abc[0], abc[2])
+    # surface average radius (rough approximation)
+    radius = np.sqrt(np.where(~selector, abc[0]*abc[1], abc[1]*abc[2]) / pi)
+
+    ddd = 0.75 * radius * (2*radius*length + (length + radius)*(length + pi*radius))
+    return 0.5 * (ddd) ** (1. / 3.)
+
+# VR defaults to 1.0
+
+# parameters for demo
+demo = dict(scale=1, background=0,
+            sld=6.3, sld_solvent=1.0,
+            length_a=35, length_b=75, length_c=400,
+            theta=45, phi=30, psi=15,
+            length_a_pd=0.1, length_a_pd_n=10,
+            length_b_pd=0.1, length_b_pd_n=1,
+            length_c_pd=0.1, length_c_pd_n=1,
+            theta_pd=10, theta_pd_n=1,
+            phi_pd=10, phi_pd_n=1,
+            psi_pd=10, psi_pd_n=10)
+# rkh 7/4/17 add random unit test for 2d, note make all params different, 2d values not tested against other codes or models
+qx, qy = 0.2 * cos(pi/6.), 0.2 * sin(pi/6.)
+tests = [[{}, 0.2, 0.17758004974],
+         [{}, [0.2], [0.17758004974]],
+         [{'theta':10.0, 'phi':20.0}, (qx, qy), 0.0089517140475],
+         [{'theta':10.0, 'phi':20.0}, [(qx, qy)], [0.0089517140475]],
+        ]
+del qx, qy  # not necessary to delete, but cleaner
Index: sasmodels/models/barbell.c
===================================================================
--- sasmodels/models/barbell.c	(revision 592343f7d47ec3aad7ffa1ca242acb1346553ede)
+++ sasmodels/models/barbell.c	(revision 2a0b2b133086c070f586ead5c4a343a7e57ecad5)
@@ -10,6 +10,6 @@
 //barbell kernel - same as dumbell
 static double
-_bell_kernel(double q, double h, double radius_bell,
-             double half_length, double sin_alpha, double cos_alpha)
+_bell_kernel(double qab, double qc, double h, double radius_bell,
+             double half_length)
 {
     // translate a point in [-1,1] to a point in [lower,upper]
@@ -26,12 +26,12 @@
     //    m = q R cos(alpha)
     //    b = q(L/2-h) cos(alpha)
-    const double m = q*radius_bell*cos_alpha; // cos argument slope
-    const double b = q*(half_length-h)*cos_alpha; // cos argument intercept
-    const double qrst = q*radius_bell*sin_alpha; // Q*R*sin(theta)
+    const double m = radius_bell*qc; // cos argument slope
+    const double b = (half_length-h)*qc; // cos argument intercept
+    const double qab_r = radius_bell*qab; // Q*R*sin(theta)
     double total = 0.0;
     for (int i = 0; i < 76; i++){
         const double t = Gauss76Z[i]*zm + zb;
         const double radical = 1.0 - t*t;
-        const double bj = sas_2J1x_x(qrst*sqrt(radical));
+        const double bj = sas_2J1x_x(qab_r*sqrt(radical));
         const double Fq = cos(m*t + b) * radical * bj;
         total += Gauss76Wt[i] * Fq;
@@ -44,11 +44,10 @@
 
 static double
-_fq(double q, double h,
-    double radius_bell, double radius, double half_length,
-    double sin_alpha, double cos_alpha)
+_fq(double qab, double qc, double h,
+    double radius_bell, double radius, double half_length)
 {
-    const double bell_fq = _bell_kernel(q, h, radius_bell, half_length, sin_alpha, cos_alpha);
-    const double bj = sas_2J1x_x(q*radius*sin_alpha);
-    const double si = sas_sinx_x(q*half_length*cos_alpha);
+    const double bell_fq = _bell_kernel(qab, qc, h, radius_bell, half_length);
+    const double bj = sas_2J1x_x(radius*qab);
+    const double si = sas_sinx_x(half_length*qc);
     const double cyl_fq = 2.0*M_PI*radius*radius*half_length*bj*si;
     const double Aq = bell_fq + cyl_fq;
@@ -84,5 +83,5 @@
         double sin_alpha, cos_alpha; // slots to hold sincos function output
         SINCOS(alpha, sin_alpha, cos_alpha);
-        const double Aq = _fq(q, h, radius_bell, radius, half_length, sin_alpha, cos_alpha);
+        const double Aq = _fq(q*sin_alpha, q*cos_alpha, h, radius_bell, radius, half_length);
         total += Gauss76Wt[i] * Aq * Aq * sin_alpha;
     }
@@ -103,7 +102,9 @@
     double q, sin_alpha, cos_alpha;
     ORIENT_SYMMETRIC(qx, qy, theta, phi, q, sin_alpha, cos_alpha);
+    const double qab = q*sin_alpha;
+    const double qc = q*cos_alpha;
 
     const double h = -sqrt(square(radius_bell) - square(radius));
-    const double Aq = _fq(q, h, radius_bell, radius, 0.5*length, sin_alpha, cos_alpha);
+    const double Aq = _fq(qab, qc, h, radius_bell, radius, 0.5*length);
 
     // Multiply by contrast^2 and convert to cm-1
